#include <SPI.h>
#include <SoftwareSerial.h>
#include <MFRC522.h>
#include <Wire.h>
//Buzzer
#define buzzer 8
//RS485
#define rs485_RX A0
#define rs485_TX A1
#define rs485_DE A2
#define rs485_RE A3
SoftwareSerial rs485(rs485_RX, rs485_TX); // RX, TX
String MASTER_PORT = "FF";
String newCard="";
//RFID
#define SS_PIN 10
#define RST_PIN 9
MFRC522 mfrc522(SS_PIN, RST_PIN);

char incomingByte;
String command;
boolean messageCompleted = false;
boolean newMessage = false;

void setup() {
  pinMode(rs485_RE, OUTPUT);
  pinMode(rs485_DE, OUTPUT);
  digitalWrite(rs485_RE, LOW);
  digitalWrite(rs485_DE, LOW);
  Serial.begin(9600);
  rs485.begin(19200);
  SPI.begin();      // Initiate  SPI bus
  mfrc522.PCD_Init();   // Initiate MFRC522
}

void loop() {
  serialCommunication();
  readCard();
  rs485Communication();
}
void readCard() {
  if ( ! mfrc522.PICC_IsNewCardPresent())
  {
    return;
  }
  // Select one of the cards
  if ( ! mfrc522.PICC_ReadCardSerial())
  {
    return;
  }
  //Show UID on serial monitor
  String card = "";
  for (byte i = 0; i < mfrc522.uid.size; i++)
  {
    card.concat(String(mfrc522.uid.uidByte[i] < 0x10 ? " 0" : " "));
    card.concat(String(mfrc522.uid.uidByte[i], HEX));
  }
  card.toUpperCase();
  card = card.substring(1);
  card.replace(" ", "");
  newCard = card;
  tone(buzzer,500,300);
}
void serialCommunication() {
  if (rs485.available()) {
    incomingByte = rs485.read();
    if (incomingByte == '>') {
      messageCompleted = true;
      newMessage = false;
    }
    else if (incomingByte == '<') {
      newMessage = true;
    }

    if (newMessage) {
      command.concat(incomingByte);
    }
  }

  if (messageCompleted) {
    if (command.substring(1, 3) == MASTER_PORT) {
      if (command.charAt(3) == 't') {
        Serial.println(command.substring(4));
      }
      else if (command.charAt(3) == 'c') {
        String index = command.substring(4,5);
        String card = command.substring(5);
        card.replace("xxxxxxxx","NOT SET");
        Serial.println(index+": "+card);
      }
      //Report last check to master - time and card id
      else if (command.charAt(3) == 'r') {
        Serial.println(command.substring(4));
      }
    }
    command = "";
    messageCompleted = false;
  }
}
void rs485Communication(){
  if (Serial.available()) {
    incomingByte = Serial.read();
    if (incomingByte == '>') {
      messageCompleted = true;
      newMessage = false;
    }
    else if (incomingByte == '<') {
      newMessage = true;
    }

    if (newMessage) {
      command.concat(incomingByte);
    }
  }
  if (messageCompleted) {
    if (command.substring(1, 3) != MASTER_PORT) {
      digitalWrite(rs485_DE,HIGH);
      rs485.print(command+">");
    }   
    else{
      Serial.println(newCard);
      newCard="";
    }
    command = "";
    messageCompleted = false;
  }
  digitalWrite(rs485_DE,LOW);
}

